//                    ******************
//                    *Animation Tester*
//                    * By R.Yates     *
//                    ******************
#include <graph3.h>
#include <graph4.h>
#include <graph7k.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
pcx_picture back;  // array of memory for background picture
pcx_picture fimage; // array of memory for frame picture
sprite frames;       // array of memory for frames
char Data[128];     // input data
int eof; // end of frames
int speed;   // animation speed
int index; // loop control
int flag;   // can't remember
int sf;    // show flag
int NumFrames;   // figure it out your self
unsigned char key;

void Intro(void)
{
PCX_Init((pcx_picture_ptr)&back);
PCX_Load("i1.pcx",(pcx_picture_ptr)&back,0);
PCX_Show_Buffer((pcx_picture_ptr)&back);
PCX_Delete((pcx_picture_ptr)&back);
}

void UN(void)
{
PCX_Init((pcx_picture_ptr)&back);
PCX_Load("B2u.pcx",(pcx_picture_ptr)&back,0);
PCX_Show_Buffer((pcx_picture_ptr)&back);
PCX_Delete((pcx_picture_ptr)&back);
}


void Back(void)
{
PCX_Init((pcx_picture_ptr)&back);
PCX_Load("b2.pcx",(pcx_picture_ptr)&back,0);
PCX_Show_Buffer((pcx_picture_ptr)&back);
PCX_Delete((pcx_picture_ptr)&back);
}
void LoadPal(void)
{
PCX_Init((pcx_picture_ptr)&back);
PCX_Load("b2.pcx",(pcx_picture_ptr)&back,1);
PCX_Delete((pcx_picture_ptr)&back);
}

void Animate(void)
{
frames.curr_frame=-1;
frames.x=60;
frames.y=70;
Behind_Sprite((sprite_ptr)&frames);

while(!kbhit()){
Erase_Sprite((sprite_ptr)&frames);
Behind_Sprite((sprite_ptr)&frames);
frames.curr_frame=frames.curr_frame+1;
if (frames.curr_frame>=NumFrames) frames.curr_frame=0;
Draw_Sprite((sprite_ptr)&frames);
delay(speed);}
Erase_Sprite((sprite_ptr)&frames);

}


void SP(void)
{
sprite_width=20;
sprite_height=20;
PCX_Init((pcx_picture_ptr)&fimage);
PCX_Load(Data,(pcx_picture_ptr)&fimage,1);
PCX_Show_Buffer((pcx_picture_ptr)&fimage);
Sprite_Init((sprite_ptr)&frames,20,100,0,0,0,0);

for (index=0; index<NumFrames; index++){
PCX_Grab_Bitmap((pcx_picture_ptr)&fimage,(sprite_ptr)&frames,index,index,0);}
flag=1;
PCX_Delete((pcx_picture_ptr)&fimage);

}


void Dis_13(void)
{
frames.curr_frame=0;
frames.x=1;
eof=NumFrames;
for (index=0; index<eof; index++){
Draw_Sprite((sprite_ptr)&frames);
frames.curr_frame=index+1;
frames.x=frames.x+21; }
while (!kbhit()){};
}

void Dis_16(void)
{
frames.curr_frame=0;
frames.x=1;
for (index=0; index<15; index++){
Draw_Sprite((sprite_ptr)&frames);
frames.curr_frame=index+1;
frames.x=frames.x+21; }
frames.curr_frame=15;
frames.x=1;
frames.y=frames.y+21;
Draw_Sprite((sprite_ptr)&frames);
while (!kbhit()){};
}



void main()
{
int done;
int done2;
int af;
flag=0;
Set_Video_Mode(VGA256);
sprite_width=20;
sprite_height=20;
NumFrames=0;
speed=250;
Intro();
while(!kbhit()){}
LoadPal();
Back();
while (!done)
{
if ((key=Get_Scan_Code()))
{printf("",key);}

if (key==SCAN_E) { done=1;}
if (key==SCAN_L) {
					  Fill_VGA(0);
					  gotoxy(2,10);
					  printf("PATH/FILENAME.PCX: ");
					  Get_Line(Data);
					  Fill_VGA(0);
					  gotoxy(2,10);
					  printf("How Many Frames Would You Like To Grab?: ");
					  scanf("%d",&NumFrames);
					  af=1;
					  sf=1;
					  SP();
					  Back();
										  }
if (key==SCAN_S & sf==1) {
					  Fill_VGA(0);
					  gotoxy(10,1);
					  printf("Frames 0-15");
					 //  if (NumFrames>=17) gotoxy(1,14); printf("A 20x20 frame screen can only have a Maxminum of 16 Frames"); while(!kbhit()){}; SP();
					  if (NumFrames<=15) Dis_13();


					  while (!kbhit()){};
					  Back();


					  }
if (key==SCAN_A & af==1) {
					  Animate();
					  }
if (key==SCAN_F) {
					  Fill_VGA(0);
					  gotoxy(1,1);
					  printf("Default Speed = 200");
					  gotoxy(1,10);
					  printf("Please Enter A Speed: ");
					  scanf("%d",&speed);
					  Data=="b2.pcx";
					  Back();

					  }
if (key==SCAN_U) {
					  UN();
					  while(!kbhit()){};
					  Back();
					  }
					  }
Disolve();
Set_Video_Mode(TEXT_MODE);
}